//{ ====== VNUTORNE VECI
//{ --- Nastavenia
#define PLAYERS 4
//#define INFO_PLAYER_UPGRADES 0 //poskytuje additional info o tom kto si kedy co upgradoval a kupil, 
                               //na neprezradenie strategie moze byt doporucene vypnut :)
//}                              
//{ --- Server
#define SERVER_PORT 4221
#define SERVER_IP "127.0.0.1"
//}
//{ --- Nejake potrebne definy
#include<queue>
#include<map>
#include<iostream>
#include<math.h>

#define DATA_SEEMS_OK 4747
#define DATA_NOT_OK 4242
#define SLEEP_TIME_CONNECTION 100

#define REP(i,n) for(int i=0;i<(n);++i)
//} 
//}
//{ ====== HERNE NASTAVENIA
//{ --- Doladovacie konstanty
//neskor sa budu loadovat zo suboru a budu sa menit podla hry, ale budu pomenovane rovnako
#define SIRKALINIE 70 //resetuje sa na polovicu
#define DIE_IF_NO_OPPONENT 0
//ak je 1, jednotky poslane na bojisko zomru aj ked nepriatel ziadne neposlal... 
//utopia sa v bazinach, zomru nudou, alebo inym sposobom sa stratia z povrchu zemskeho
//#define STARTMONEY 47 //zaciatocne cashe
//#define STARTARMY 47 //zaciatocna armada
#define N_TECH 5 //pocet technologickych stupnov
#define N_STAT 3 //pocet statistik vojaka... pre vas asi nezaujimave
#define AU(n) UPGRADE_CENA*(n) //cena za upgrade utoku/defence na Nty level
#define BUY_ARMY(n) (((n)*(n)+4)/5+2*(n)) //cena prikupenia N vojakov
//#define ADDARMY 10 //pocet vojakov ktori pribudnu kazde kolo
//#define BODY_KILL 1 //Pocet bodov za 1 kill
//#define BODY_DOBITIE 4700
//#define BODY_DOBITIE 740 //body za dobitie nepriatelskej veze
//#define CASHZAKILL 1 //pocet penazi za 1 kill

int __a[5][3],t[5],STARTMONEY,STARTARMY,UPGRADE_CENA,ADDARMY,BODY_KILL,BODY_DOBITIE,CASHZAKILL;
int techprices[N_TECH];//ceny jednotlivych technologickych stupnov
struct CUnit { int stat[N_STAT]; };//vojacik, pandrlak, typec...
CUnit techlevels[N_TECH];//jednotlive statistiky jednotiek pre technologicke levely

void inittechlevels(){
//int techlevels_old[N_TECH][N_STAT];
  //just hack, potom loadovat!!!
  REP(i,N_TECH) REP(j,N_STAT) techlevels[i].stat[j]=__a[i][j];
  REP(i,N_TECH) techprices[i]=t[i];
};


int zmenkonstanty(int f){
int aa0[5][3]={{5,3,4},{5,3,3},{7,6,8},{6,6,7},{13,10,12}};
int aa1[5][3]={{10,3,4},{20,6,8},{40,10,12},{40,10,12},{40,10,12}};
int aa2[5][3]={{10,3,4},{20,6,8},{40,10,12},{20,20,20},{20,20,20}};
int aa3[5][3]={{5,3,4},{7,6,8},{13,10,12},{13,10,12},{13,10,12}};
int aa4[5][3]={{5,3,3},{5,3,4},{6,6,7},{7,6,8},{13,10,12}};
int aa5[5][3]={{10,3,3},{20,6,9},{40,15,25},{60,42,47},{90,56,64}};
int aa6[5][3]={{5,3,3},{5,3,4},{6,6,7},{7,6,8},{13,10,12}};
int aa7[5][3]={{10,3,4},{20,6,8},{40,10,12},{40,10,12},{40,10,12}};


 switch (f) {
  case 0:
    STARTMONEY=47;
    STARTARMY=47;
    UPGRADE_CENA=50;
    ADDARMY=10;
    BODY_KILL=1;
    BODY_DOBITIE=740;
    CASHZAKILL=1;
    for (int i=0;i<5;i++) t[i]=i*400;
    REP(i,5) REP(j,3)__a[i][j]=aa0[i][j];
  break;
  case 1:
    STARTMONEY=47;
    STARTARMY=47;
    UPGRADE_CENA=50;
    ADDARMY=10;
    BODY_KILL=1;
    BODY_DOBITIE=740;
    CASHZAKILL=5;
    for (int i=0;i<5;i++) t[i]=i*400;
    t[3]=0;
    t[4]=0;
    REP(i,5) REP(j,3)__a[i][j]=aa1[i][j];

  break;
  case 2:
    STARTMONEY=47;
    STARTARMY=47;
    UPGRADE_CENA=12;
    ADDARMY=50;
    BODY_KILL=1;
    BODY_DOBITIE=740;
    CASHZAKILL=1;
    for (int i=0;i<5;i++) t[i]=i*400;
    t[4]=0;
    REP(i,5) REP(j,3)__a[i][j]=aa2[i][j];

  break;
  case 3:
     STARTMONEY=47;
    STARTARMY=20;
    UPGRADE_CENA=15;
    ADDARMY=3;
    BODY_KILL=1;
    BODY_DOBITIE=740;
    CASHZAKILL=5;
    t[0]=0;
    t[1]=100;
    t[2]=300;
    t[3]=0;
    t[4]=0;
    REP(i,5) REP(j,3)__a[i][j]=aa3[i][j];

  break;
  case 4:
    STARTMONEY=11147;
    STARTARMY=47;
    UPGRADE_CENA=50;
    ADDARMY=10;
    BODY_KILL=1;
    BODY_DOBITIE=740;
    CASHZAKILL=2;
    for (int i=0;i<5;i++) t[i]=i*1400;
    REP(i,5) REP(j,3)__a[i][j]=aa4[i][j];

  break;
  case 5:
    STARTMONEY=0;
    STARTARMY=0;
    UPGRADE_CENA=30;
    ADDARMY=20;
    BODY_KILL=1;
    BODY_DOBITIE=740;
    CASHZAKILL=2;
    for (int i=0;i<5;i++) t[i]=i*450;
    REP(i,5) REP(j,3)__a[i][j]=aa5[i][j];

  break;
  case 6:
    STARTMONEY=13;
    STARTARMY=89;
    UPGRADE_CENA=100;
    ADDARMY=8;
    BODY_KILL=1;
    BODY_DOBITIE=740;
    CASHZAKILL=1;
    for (int i=0;i<5;i++) t[i]=i*80;
    REP(i,5) REP(j,3)__a[i][j]=aa6[i][j];

  break;
  case 7:
    STARTMONEY=47;
    STARTARMY=47;
    UPGRADE_CENA=50;
    ADDARMY=10;
    BODY_KILL=1;
    BODY_DOBITIE=740;
    CASHZAKILL=5;
    for (int i=0;i<5;i++) t[i]=i*400;
    t[3]=0;
    t[4]=0;
    REP(i,5) REP(j,3)__a[i][j]=aa7[i][j];

  break;
}
inittechlevels();
return 0;
}
//}
//{ --- Ovladacie konst.
#define UPGRADE_ATTACK 1 //turn.upgrade=UPGRADE_ATTACK | UPGRADE_ARMY sa snazi upgradovat armadu a utok
#define UPGRADE_DEFENCE 2
#define UPGRADE_ARMY 4

#define BATTLE_NONE 0//nebola bitka
#define BATTLE_WIN 1//vyhral bitku
#define BATTLE_LOST 2//prehral

#define HP 0//ehm :)
#define SH 1
#define DMG 2

#define STATE_RUNNING 1
//}
//{  Dolezite struktury

//{ CTurn
struct CTurn 
{ 
  int front[PLAYERS],//kolko jednotiek posiela na ktoru liniu
      upgrade,//ci chce upgrade
      round,//useless
      buy;//kolko vojakov chce kupit
  CTurn();//konstruktor, useless
};

CTurn::CTurn() {for(int i=0; i<PLAYERS; i++) front[i]=0; upgrade=round=buy=0;}
//}

struct CGameState
{ 
  int Linie[PLAYERS], //toto tu nie je a na 99.53% nebude... ale bolo a 0.47% nie je zanedbatelna sanca... PS: a sakra :)
  Battles[PLAYERS][PLAYERS],//([i][j] == BATTLE_WIN) <=> i vyhral nad j
  cash,//pocet cashov
  round,//kolo. asi useless
  army,//pocet vojakov
  status,
  player;//cislo hraca
};
//}
//{ Hacky a stare veci
//#define NEWBIE_PROTECT_ROUNDS 10
//poriesit co spravit ked zakape, zatial je restart na 50:50 a pridanie bodov vyhercovi
//}
