#include "player.h"
#include <math.h>
#include <algorithm>

#define FOR(i,n) for(int i=0;i<n;i++)

int NEUTRAL=3,UPG=0,T=1;

char* start_game() {
  PLAYER_NUMBER=2;
  srand(1);
  return "Gazda";
}

int end_game() {
  return 0;
}

int start_match() {
  return 0;
}

int end_match() {
  return 0;
}

int isInAttack(CGameState hra,int ind) {
	return (hra.Linie[ind]>SIRKALINIE*.15);
}

int isInDefence(CGameState hra,int ind) {
	return (hra.Linie[ind]<SIRKALINIE*.15);
}

int makeUPG(int dmg,int def,int army,int kes) {
	if(T>2 && kes>=AU(UPG+1)) {
		UPG++;
		//return(UPG%31==0)?UPGRADE_DEFENCE:UPGRADE_ATTACK;
		return UPGRADE_DEFENCE|UPGRADE_ATTACK;
	}	
	if(T<3 && techprices[T]<=kes) {
		T++;
		return UPGRADE_ARMY;
	}
                                     
	return 0;
}

int max(int a,int b) {
	return a>b?a:b;
}
int min(int a,int b) {
	return a<b?a:b;
}

int isCOLD(int x) {
	return x<3;
}	
int isHOT(int x) {
	return x>SIRKALINIE-3;
}

CTurn nextmove(CGameState hra) {
	CTurn turn;
	int dmg=0,def=0,army=0,kes=hra.cash,dog=hra.army;

	int HOT=0,COLD=0;
   	FOR(i,PLAYERS) {
		if(i!=PLAYER_NUMBER) {
			if(isCOLD(hra.Linie[i]))
				COLD++;
			else if(isHOT(hra.Linie[i]))
				HOT++;
			if(isInAttack(hra,i)) dmg++;
			else if(isInDefence(hra,i)) def++;
			else army++;	
		}	
	}	
	COLD=min(2,COLD);
	HOT=min(2,HOT);
   	FOR(i,PLAYERS) 
		if(i!=PLAYER_NUMBER)
			if(isInAttack(hra,i)) {
				if(COLD+HOT>=2) turn.front[i]=0; 
				else if(!isHOT(hra.Linie[i]) && dog>0) 
					turn.front[i]=rand()%(25*dog/100)+4;
				if(COLD<2 && dog>0 && isHOT(hra.Linie[i])) {
					turn.front[i]=dog/(COLD+HOT);
					dog-=dog/(COLD+HOT);
				}
			}
			else if(isInDefence(hra,i)) {
				if(COLD+HOT>=2) turn.front[i]=0; 
				else if(!isCOLD(hra.Linie[i]) && dog>0) 
					turn.front[i]=rand()%(20*dog/100)+4;
				if(dog>0 && isCOLD(hra.Linie[i])) {
					turn.front[i]=dog/(COLD+HOT);
					dog-=dog/(COLD+HOT);
				}
			}
			else turn.front[i]=rand()%7+10;	

	int COOP;
	turn.upgrade=COOP=makeUPG(dmg,def,army,kes);
	if(COOP) {
		if(COOP&UPGRADE_ARMY!=UPGRADE_ARMY)
			kes-=AU(UPG);
		else kes-=techprices[T];
	}		
	if(UPG>70) {	
		if(turn.round%5!=0) turn.upgrade=0;
		int x=0;
		while(BUY_ARMY(++x)<kes);	
		turn.buy=x;
		turn.buy=min(turn.buy,32);
	}
	turn.buy-=2;
	turn.buy=max(turn.buy,3);

//        for(int i=0;i < PLAYERS; i++) turn.front[i]=hra.army/3;
 //       turn.upgrade=7;

   	return turn;
}
